/*
    Copyright (C) 2012 Bartosz Broda, Jacek Bochenek, Łukasz Biłeńkij, 
    Damian Jaworski, Wojciech Mazur, Dominik Piasecki, Maciej Piasecki, 
    Radosław Ramocki
    
    This program is free software; you can redistribute it and/or modify it
under the terms of the GNU Lesser General Public License as published by the Free
Software Foundation; either version 3 of the License, or (at your option)
any later version.

    This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE. 

    See the LICENSE and COPYING files for more details.
*/

#include "../comparator_stdheaders.h"
#include "QuantizationWeight.h"

namespace smartcomparator
{
	namespace weights
	{
		QuantizationWeight::QuantizationWeight(Matrices::SuperMatrixPtr pMatrix, WeightFeaturePtr pBaseWeight, int trailing_digits, bool zeros)
			: WeightFeature(pMatrix),
			m_pBaseWeight(pBaseWeight),
			trail(trailing_digits),
			include_zeros(zeros)
		{
			// does nothing
		}

		QuantizationWeight::~QuantizationWeight()
		{
			// does nothing
		}

		void QuantizationWeight::Weight(size_t rowindex, Matrices::CompressedVector *v, std::set<size_t> &filteredIndices)
		{
			m_pBaseWeight->Weight(rowindex, v, filteredIndices);
			DoQuantization(rowindex, v, filteredIndices);
		}

		void QuantizationWeight::DoQuantization(size_t rowindex, Matrices::CompressedVector *v, std::set<size_t> &filteredIndices)
		{
			double factor = pow(10, trail);
			double value;
			for(std::set<size_t>::iterator iter = filteredIndices.begin(); iter != filteredIndices.end(); ++iter)
			{
				value = (*v)[*iter];
				v->SetElement(*iter, round(value * factor)/factor );
				if ((*v)[*iter] == 0 && include_zeros)
				    v->SetElement(*iter, 0.5 );
			}
		}
	}
}
